#!/usr/bin/env node
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("./shared/logger"));
const pkg = __importStar(require("../package.json"));
const tree_1 = __importDefault(require("./modules/tree"));
const findhelp_1 = require("findhelp");
const Bluebird = __importStar(require("bluebird"));
const path = __importStar(require("path"));
const ramda_1 = require("ramda");
const update_1 = __importDefault(require("./update"));
// check updates
update_1.default();
// print options
const VERBOSE = "--verbose";
const run = (command) => Bluebird.resolve(findhelp_1.run.call(tree_1.default, command, path.join(__dirname, "modules")));
const logToolbeltVersion = () => {
    logger_1.default.debug(`Exito version: ${pkg.version}`);
};
const main = () => __awaiter(void 0, void 0, void 0, function* () {
    const args = process.argv.slice(2);
    logToolbeltVersion();
    const command = yield findhelp_1.find(tree_1.default, ramda_1.without([VERBOSE], args));
    yield run(command);
});
const onError = (e) => {
    logger_1.default.error("Something went wrong, I don't know what to do :(");
    logger_1.default.debug(e);
    process.exit(1);
};
try {
    main().catch(onError);
}
catch (e) {
    onError(e);
}
process.on("SIGALRM", onError);
