"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("./../../shared/logger"));
const conf_1 = require("../../conf");
// Método que recibe un objeto con las credenciales y las guarda.
exports.saveCredentials = function (credentials) {
    try {
        // 1.  Guardo las credenciales indicadas
        conf_1.saveAccountAws(credentials);
        return true;
    }
    catch (e) {
        logger_1.default.debug(e);
    }
};
exports.default = (username, password) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        let user = {
            username: username,
            pwd: password
        };
        let credentials = yield exports.saveCredentials(user);
        if (credentials) {
            logger_1.default.info("Your credentials has ven saved");
        }
        else {
            logger_1.default.error("Error on save your credentials");
        }
    }
    catch (e) {
        logger_1.default.debug(e);
    }
});
