"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const logger_1 = __importDefault(require("./../../../../shared/logger"));
const read_file_1 = require("../../../../shared/util/read-file");
const directory = process.cwd();
let fs = require("fs");
function default_1(criteria) {
    return __awaiter(this, void 0, void 0, function* () {
        // 1. Leer el archivo .json y lista las dependencias filtradas de acuerdo al cricterio de busqueda, permite seleccionar las dependencias a emplear y genera un archivo config.json con las dependencias a emplear y su versión.
        logger_1.default.info("Find .json file in the current directory");
        // 1. Leo el directorio actual y permito seleccionar todos los proyectos deseados
        if (criteria) {
            logger_1.default.info(`Use the criteria ${criteria}`);
        }
        // Generación de la configuración de branch y schema
        const fileContent = yield read_file_1.readFileInDirectory(`${directory}/current-dependencies.json`, false);
        let currentDependencies = [];
        let filter = Object.keys(JSON.parse(fileContent))
            .reverse()
            .filter(item => {
            const element = item.split("@");
            currentDependencies.push(element[0]);
            return item;
        });
        let formatFilter = filter.reduce(function (prev, cur) {
            const split = cur.split("@");
            if (prev[split[0]]) {
                prev[split[0]] += '-' + split[1];
            }
            else {
                prev[split[0]] = split[1];
            }
            return prev;
        }, {});
        createFileConfig(formatFilter);
    });
}
exports.default = default_1;
/**
 * Método que sobreescribe el archivo de tema base para la aplicación.
 */
const createFileConfig = (dependencies) => __awaiter(void 0, void 0, void 0, function* () {
    return fs.writeFile(`${directory}/update-dependencies.json`, JSON.stringify(dependencies, null, 4), function (err) {
        if (err) {
            throw err;
        }
    });
});
