"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("./../../../shared/constants");
const inquirer = __importStar(require("inquirer"));
const ramda_1 = require("ramda");
const logger_1 = __importDefault(require("../../../shared/logger"));
const git = __importStar(require("./git"));
const templates = {
    'hello react typescript': 'hello-react-ts',
    'graphql getstarted': 'graphql-getstarted'
};
const promptTemplates = () => __awaiter(void 0, void 0, void 0, function* () {
    const cancel = 'Cancel';
    const chosen = ramda_1.prop('service', yield inquirer.prompt({
        name: 'service',
        message: constants_1.consts.messages.gitInitProyect,
        type: 'list',
        choices: [...ramda_1.keys(templates), cancel]
    }));
    if (chosen === cancel) {
        logger_1.default.info(constants_1.consts.messages.gitInitClose);
        return process.exit();
    }
    return chosen;
});
const promptContinue = () => __awaiter(void 0, void 0, void 0, function* () {
    const promt = yield inquirer.prompt({
        name: 'proceed',
        message: `You are about to remove all files in ${process.cwd()}. Do you want to continue?`,
        type: 'confirm'
    });
    const proceed = ramda_1.prop('proceed', promt);
    if (!proceed) {
        logger_1.default.info(constants_1.consts.messages.gitInitClose);
        process.exit();
    }
});
exports.default = () => __awaiter(void 0, void 0, void 0, function* () {
    logger_1.default.debug('Prompting for app info');
    logger_1.default.info(constants_1.consts.messages.gitInitHellow);
    try {
        const repo = templates[yield promptTemplates()];
        console.log(repo);
        yield promptContinue();
        logger_1.default.info(`Cloning https://${constants_1.consts.github_account}s/${repo}.git`);
        git.clone(repo);
    }
    catch (err) {
        logger_1.default.error(err.message);
        err.printStackTrace();
    }
});
