"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const read_files_extension_1 = require("./../../../shared/util/read-files-extension");
const logger_1 = __importDefault(require("../../../shared/logger"));
const run_only_command_1 = require("../../../shared/util/run-only-command");
const get_repository_name_1 = require("../../../shared/util/get-repository-name");
exports.runTriggers = (commandToRun) => __awaiter(void 0, void 0, void 0, function* () {
    const directory = process.cwd() + "/";
    logger_1.default.info(directory);
    // 1. Leo el directorio actual y permito seleccionar todos los proyectos deseados
    const currentDirectory = yield read_files_extension_1.readDirectoryByExtension(directory, [".json"], "Pick the file to use", "Select the .json file to use");
    const projectsList = getProjectNames(currentDirectory);
    executeTriggerUpdate(projectsList, commandToRun);
});
// Método que recorre la lista de proyectos y obtiene el nombre a emplear de acuerdo a la carpeta.
const getProjectNames = (currentDirectory) => {
    let repositoryNames = [];
    currentDirectory.map((item) => __awaiter(void 0, void 0, void 0, function* () {
        repositoryNames.push(get_repository_name_1.getRepositoryName(item.replace(".json", "")));
    }));
    return repositoryNames;
};
const executeTriggerUpdate = (projectsList, commandToRun) => {
    try {
        projectsList.map((name) => __awaiter(void 0, void 0, void 0, function* () {
            //a function that returns a promise
            const command = `aws codecommit ${commandToRun} --repository-name ${name} --cli-input-json file://${name}.json`;
            yield run_only_command_1.runOnlyCommand(command);
            logger_1.default.debug("Finish Running: " + name);
        }));
    }
    catch (error) {
        logger_1.default.error("Error on update trigger: " + error);
    }
};
