"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("./../../../shared/constants");
const log_vtex_1 = require("../../../shared/log-vtex");
const { spawn } = require("child_process");
const logger_1 = __importDefault(require("../../../shared/logger"));
exports.runCommand = function (options) {
    return new Promise(function (fulfill, reject) {
        logger_1.default.info(`Using component in the folder: ${options.path}`);
        const task = spawn(`cd ${options.path} && ${options.command}`, [], {
            shell: true
        });
        // Método para imprimir el log normal
        task.stdout.on("data", (data) => {
            logger_1.default.info(data.toString());
            if (exports.validateLog(options.command, data.toString(), "success")) {
                task.kill("SIGINT");
                fulfill(true);
            }
            if (exports.validateLog(options.command, data.toString(), "error")) {
                task.kill("SIGINT");
                fulfill(false);
                logger_1.default.error("Process error");
                process.exit(1);
            }
        });
        // Método para imprimir el log de error
        task.stderr.on("data", function (data) {
            logger_1.default.info(data.toString());
            // Validación en caso de error
            if (exports.validateLog(options.command, data.toString(), "error")) {
                task.kill("SIGINT");
                reject(false);
                logger_1.default.error("Process error");
                process.exit(1);
            }
            if (exports.validateLog(options.command, data.toString(), "success")) {
                task.kill("SIGINT");
                fulfill(true);
            }
        });
    });
};
/**
 * Método para validar que tipo de mensaje se esta retornando
 * command: string
 * type: string
 */
exports.validateLog = (command, logMessage, type) => {
    if (command == constants_1.consts.link) {
        if (type == "success") {
            const isFind = !!log_vtex_1.link_success_log.find((element) => logMessage.includes(element.log));
            return isFind;
        }
        else if (type == "error") {
            const isFind = !!log_vtex_1.link_error_log.find((element) => logMessage.includes(element.log));
            return isFind;
        }
    }
    else if (command == constants_1.consts.publish) {
        if (type == "success") {
            const isFind = !!log_vtex_1.publish_success_log.find((element) => logMessage.includes(element.log));
            return isFind;
        }
        else if (type == "error") {
            const isFind = !!log_vtex_1.publish_error_log.find((element) => logMessage.includes(element.log));
            return isFind;
        }
    }
};
