"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const chalk_1 = __importDefault(require("chalk"));
const inquirer_1 = __importDefault(require("inquirer"));
const logger_1 = __importDefault(require("../../../shared/logger"));
// Método que busca una dependencia e la lista de dependencias filtradas por el usuario
exports.findDependency = (dependenciesList) => __awaiter(void 0, void 0, void 0, function* () {
    let filderDependencies = yield choiseDependencies(dependenciesList);
    if (filderDependencies.dependencies) {
        dependenciesList = yield dependenciesList.filter((item) => {
            let isFind = filderDependencies.dependencies.find((filter) => {
                // Valido si la dependencia ha sido seleccionada, si no esta seleccionda. armo un array solo con dependencias selecionadas
                if (item.value == filter) {
                    return true;
                }
                else {
                    return false;
                }
            });
            return isFind;
        });
        logger_1.default.info(`Total of proyects to link: ${chalk_1.default.whiteBright(`${dependenciesList.length}`)}`);
        return dependenciesList;
    }
    else {
        return [];
    }
});
const choiseDependencies = (dependenciesList) => __awaiter(void 0, void 0, void 0, function* () {
    let dependencies = [
        new inquirer_1.default.Separator(`${chalk_1.default.whiteBright('Select the proyects to use')} \n`),
        ...dependenciesList
    ];
    const promptCommands = yield inquirer_1.default.prompt([
        {
            type: 'checkbox',
            message: `${chalk_1.default.redBright('Pick proyects to link')}`,
            name: 'dependencies',
            choices: dependencies
        }
    ]);
    return promptCommands;
});
